Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
DestTextureImage Class Reference

This represents a texture filename as it has been resized and copied to the map directory (e.g. More...

`#include "destTextureImage.h"`

Inheritance diagram for DestTextureImage:

## Public Member Functions
| DestTextureImage (TexturePlacement *placement)
void | copy (TextureImage *texture)
| Unconditionally copies the source texture into the appropriate filename.
void | copy_if_stale (const DestTextureImage *other, TextureImage *texture)
| Copies the source texture into the appropriate filename only if the indicated old reference, which represents the way it was last copied, is now out-of-date.
virtual TypeHandle | get_type () const
virtual void | write_datagram (BamWriter *writer, Datagram &datagram)
| Fills the indicated datagram up with a binary representation of the current object, in preparation for writing to a Bam file.
Public Member Functions inherited from ImageFile
void | clear_basic_properties ()
| Resets the properties to a neutral state, for instance in preparation for calling update_properties() with all the known contributing properties.
virtual int | complete_pointers (TypedWritable **p_list, BamReader *manager)
| Called after the object is otherwise completely read from a Bam file, this function's job is to store the pointers that were retrieved from the Bam file for each pointer object written.
bool | exists () const
| Returns true if the file or files named by the image file exist, false otherwise.
int | get_alpha_file_channel () const
| Returns the particular channel number of the alpha image file from which the alpha channel should be extracted.
const Filename & | get_alpha_filename () const
| Returns the alpha filename of the image file.
const Filename & | get_filename () const
| Returns the primary filename of the image file.
int | get_num_channels () const
| Returns the number of channels of the image.
const TextureProperties & | get_properties () const
| Returns the grouping properties of the image.
int | get_x_size () const
| Returns the size of the image file in pixels in the X direction.
int | get_y_size () const
| Returns the size of the image file in pixels in the Y direction.
bool | has_num_channels () const
| Returns true if the number of channels in the image is known, false otherwise.
bool | is_size_known () const
| Returns true if the size of the image file is known, false otherwise.
bool | make_shadow_image (const std::string &basename)
| Sets up the ImageFile as a "shadow image" of a particular PaletteImage.
void | output_filename (std::ostream &out) const
| Writes the filename (or pair of filenames) to the indicated output stream.
bool | read (PNMImage &image) const
| Reads in the image (or images, if the alpha_filename is separate) and stores it in the indicated PNMImage.
bool | set_filename (const std::string &dirname, const std::string &basename)
| Sets the filename, and if applicable, the alpha_filename, from the indicated basename.
bool | set_filename (PaletteGroup *group, const std::string &basename)
| Sets the filename, and if applicable, the alpha_filename, from the indicated basename.
void | unlink ()
| Deletes the image file or files.
void | update_egg_tex (EggTexture *egg_tex) const
| Sets the indicated EggTexture to refer to this file.
void | update_properties (const TextureProperties &properties)
| If the indicate TextureProperties structure is more specific than this one, updates this one.
bool | write (const PNMImage &image) const
| Writes out the image in the indicated PNMImage to the _filename and/or _alpha_filename.
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type.
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object.
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string.
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.
virtual TypeHandle | force_init_type ()
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter.
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams.
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
static void | register_with_read_factory ()
| Registers the current object as something that can be read from a Bam file.
Static Public Member Functions inherited from ImageFile
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.

## Additional Inherited Members
Public Attributes inherited from TypedObject
| get_type
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

This represents a texture filename as it has been resized and copied to the map directory (e.g.

for an unplaced texture).

Definition at line 28 of file destTextureImage.h.

## Constructor & Destructor Documentation

## ◆ DestTextureImage()

DestTextureImage::DestTextureImage | ( | TexturePlacement * | placement | ) |

Definition at line 38 of file destTextureImage.cxx.

## Member Function Documentation

## ◆ copy()

void DestTextureImage::copy | ( | TextureImage * | texture | ) |

Unconditionally copies the source texture into the appropriate filename.

Definition at line 62 of file destTextureImage.cxx.

References PNMImage::alpha_fill(), PNMImage::fill(), PNMImageHeader::get_maxval, ImageFile::get_num_channels(), PNMImageHeader::has_alpha(), PNMImage::is_valid(), PNMImage::quick_filter_from(), TextureImage::read_source_image(), TextureImage::release_source_image(), and ImageFile::write().

Referenced by copy_if_stale().

## ◆ copy_if_stale()

void DestTextureImage::copy_if_stale | ( | const DestTextureImage * | other,
|  | TextureImage * | texture )

Copies the source texture into the appropriate filename only if the indicated old reference, which represents the way it was last copied, is now out-of-date.

Definition at line 90 of file destTextureImage.cxx.

References Filename::compare_timestamps(), copy(), ImageFile::get_filename(), ImageFile::get_num_channels(), TextureImage::get_preferred_source(), ImageFile::get_x_size(), and ImageFile::get_y_size().

## ◆ get_class_type()

static TypeHandle DestTextureImage::get_class_type | ( |  | ) |
| inline static

Definition at line 52 of file destTextureImage.h.

## ◆ get_type()

virtual TypeHandle DestTextureImage::get_type | ( |  | ) | const
| inline virtual

Reimplemented from ImageFile.

Definition at line 60 of file destTextureImage.h.

## ◆ init_type()

static void DestTextureImage::init_type | ( |  | ) |
| inline static

Definition at line 55 of file destTextureImage.h.

## ◆ register_with_read_factory()

void DestTextureImage::register_with_read_factory | ( |  | ) |
| static

Registers the current object as something that can be read from a Bam file.

Definition at line 123 of file destTextureImage.cxx.

References BamReader::get_factory().

Referenced by init_palettizer().

## ◆ write_datagram()

void DestTextureImage::write_datagram | ( | BamWriter * | writer,
|  | Datagram & | datagram )
| virtual

Fills the indicated datagram up with a binary representation of the current object, in preparation for writing to a Bam file.

Reimplemented from ImageFile.

Definition at line 133 of file destTextureImage.cxx.

References ImageFile::write_datagram().

The documentation for this class was generated from the following files:

- pandatool/src/palettizer/destTextureImage.h
- pandatool/src/palettizer/destTextureImage.cxx